<?xml version="1.0" encoding="utf-8"?>
<layout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:app="http://schemas.android.com/apk/res-auto"
    xmlns:tools="http://schemas.android.com/tools">

    <data>

        <variable
            name="vm"
            type="pl.codepunk.receiptvault.ui.viewmodel.AccessViewModel" />
    </data>

    <ScrollView
        android:layout_width="match_parent"
        android:layout_height="match_parent"
        android:animateLayoutChanges="true"
        android:background="?attr/backgroundColor"
        android:fillViewport="true">

        <androidx.constraintlayout.widget.ConstraintLayout
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:clipChildren="false"
            android:clipToPadding="false"
            tools:context=".ui.fragments.AccessFragment">

            <LinearLayout
                android:id="@+id/login"
                android:layout_width="0dp"
                android:layout_height="wrap_content"
                android:layout_marginStart="32dp"
                android:layout_marginTop="32dp"
                android:layout_marginEnd="32dp"
                android:layout_marginBottom="32dp"
                android:orientation="vertical"
                app:layout_constraintBottom_toTopOf="@+id/bottom"
                app:layout_constraintEnd_toEndOf="parent"
                app:layout_constraintStart_toStartOf="parent"
                app:layout_constraintTop_toBottomOf="@+id/header">

                <TextView
                    android:id="@+id/title"
                    style="@style/Text.h2"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_marginStart="3dp"
                    android:text="@string/access_password_input_request" />

                <com.google.android.material.textfield.TextInputLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    app:passwordToggleEnabled="true"
                    app:passwordToggleTint="?attr/infoTextColor">

                    <com.google.android.material.textfield.TextInputEditText
                        android:id="@+id/passwordEntry"
                        style="@style/EditText.password"
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:inputType="textPassword"
                        android:onTextChanged="@{(text, start, before, count) -> vm.setPassword(text.toString())}"
                        android:text="@{vm.cachedPassword}" />
                </com.google.android.material.textfield.TextInputLayout>

                <TextView
                    android:id="@+id/error"
                    style="@style/Text.h3.error"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:gravity="left"
                    app:errorCode="@{safeUnbox(vm.errorCode)}"
                    tools:visibility="visible" />

            </LinearLayout>

            <TextView
                android:id="@+id/header"
                style="@style/Text.h1"
                android:layout_width="0dp"
                android:layout_height="wrap_content"
                android:padding="24dp"
                android:text="@string/access_header"
                app:layout_constraintBottom_toTopOf="@+id/login"
                app:layout_constraintEnd_toEndOf="parent"
                app:layout_constraintStart_toStartOf="parent"
                app:layout_constraintTop_toTopOf="parent"
                app:layout_constraintVertical_chainStyle="spread_inside" />

            <androidx.constraintlayout.widget.ConstraintLayout
                android:id="@+id/bottom"
                android:layout_width="0dp"
                android:layout_height="wrap_content"
                android:layout_marginStart="32dp"
                android:layout_marginEnd="32dp"
                android:layout_marginBottom="32dp"
                app:layout_constraintBottom_toBottomOf="parent"
                app:layout_constraintEnd_toEndOf="parent"
                app:layout_constraintStart_toStartOf="parent"
                app:layout_constraintTop_toBottomOf="@+id/login">

                <TextView
                    android:id="@+id/forgotPassword"
                    style="@style/Text.h3.info"
                    android:layout_width="wrap_content"
                    android:layout_height="wrap_content"
                    android:onClick="@{(v) -> vm.forgotPassword()}"
                    android:padding="@dimen/clickArea"
                    android:text="@string/access_password_reset"
                    app:layout_constraintBottom_toBottomOf="parent"
                    app:layout_constraintEnd_toStartOf="@+id/continueButton"
                    app:layout_constraintHorizontal_bias="0.5"
                    app:layout_constraintHorizontal_chainStyle="spread_inside"
                    app:layout_constraintStart_toStartOf="parent"
                    app:layout_constraintTop_toTopOf="parent" />

                <com.google.android.material.floatingactionbutton.FloatingActionButton
                    android:id="@+id/continueButton"
                    android:layout_width="wrap_content"
                    android:layout_height="wrap_content"
                    android:layout_marginStart="8dp"
                    android:backgroundTint="?attr/fabColor"
                    android:onClick="@{(v) -> vm.login()}"
                    app:srcCompat="?attr/fabNextIcon"
                    app:borderWidth="0dp"
                    app:fabCustomSize="50dp"
                    app:tint="?attr/fabIconColor"
                    app:layout_constraintBottom_toBottomOf="parent"
                    app:layout_constraintEnd_toEndOf="parent"
                    app:layout_constraintHorizontal_bias="0.5"
                    app:layout_constraintStart_toEndOf="@+id/forgotPassword"
                    app:layout_constraintTop_toTopOf="parent" />
            </androidx.constraintlayout.widget.ConstraintLayout>

        </androidx.constraintlayout.widget.ConstraintLayout>

    </ScrollView>

</layout>